import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _componentType;
var _excluded = ["type"],
  _excluded2 = ["type"],
  _excluded3 = ["type", "button", "leftAddon", "rightAddon", "leftIcon", "rightIcon", "children", "onClickLeftIcon", "onClickRightIcon", "size"];
import { forwardRef } from 'react';
import cx from 'classnames';
import PropTypes from 'prop-types';
import { BASE_CLASS_AREA_FOCUSABLE, BASE_CLASS_ITEM, SIZES, TYPES } from '../config.js';
import Mask from '../Mask/index.js';
import Password from '../Password/index.js';
import Input from './Component/index.js';
import InputAddons from './Wrappers/Addons/InputAddons.js';
import InputButton from './Wrappers/Button/InputButton.js';
import InputIcons from './Wrappers/Icons/InputIcons.js';
import { jsx as _jsx } from "react/jsx-runtime";
var componentType = (_componentType = {
  undefined: function undefined(props) {
    return [Input, props];
  }
}, _componentType[TYPES.SUI_PASSWORD] = function (_ref) {
  var type = _ref.type,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  return [Password, _extends({}, props)];
}, _componentType[TYPES.MASK] = function (_ref2) {
  var type = _ref2.type,
    props = _objectWithoutPropertiesLoose(_ref2, _excluded2);
  return [Mask, _extends({}, props)];
}, _componentType);
var BaseInput = /*#__PURE__*/forwardRef(function (_ref3, forwardedRef) {
  var type = _ref3.type,
    button = _ref3.button,
    leftAddon = _ref3.leftAddon,
    rightAddon = _ref3.rightAddon,
    leftIcon = _ref3.leftIcon,
    rightIcon = _ref3.rightIcon,
    children = _ref3.children,
    onClickLeftIcon = _ref3.onClickLeftIcon,
    onClickRightIcon = _ref3.onClickRightIcon,
    _ref3$size = _ref3.size,
    size = _ref3$size === void 0 ? SIZES.MEDIUM : _ref3$size,
    inputProps = _objectWithoutPropertiesLoose(_ref3, _excluded3);
  var _ref4 = componentType[type] ? componentType[type](_extends({
      type: type,
      size: size
    }, inputProps)) : componentType[undefined](_extends({
      type: type,
      size: size
    }, inputProps)),
    Component = _ref4[0],
    passedProps = _ref4[1];
  return /*#__PURE__*/_jsx(InputButton, {
    button: button,
    children: /*#__PURE__*/_jsx(InputAddons, {
      leftAddon: leftAddon,
      rightAddon: rightAddon,
      shape: inputProps.shape,
      size: size,
      children: /*#__PURE__*/_jsx("span", {
        className: cx(BASE_CLASS_ITEM, BASE_CLASS_AREA_FOCUSABLE),
        children: /*#__PURE__*/_jsx(InputIcons, {
          leftIcon: leftIcon,
          rightIcon: rightIcon,
          onClickLeftIcon: onClickLeftIcon,
          onClickRightIcon: onClickRightIcon,
          children: /*#__PURE__*/_jsx(Component, _extends({
            ref: forwardedRef
          }, passedProps, {
            size: size,
            children: children
          }))
        })
      })
    })
  });
});
export default BaseInput;
export { BaseInput };