import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["type", "shape", "charsSize", "size", "noBorder", "errorState", "state", "disabled", "readOnly"];
import { forwardRef } from 'react';
import cx from 'classnames';
import PropTypes from 'prop-types';
import Input from './Input/index.js';
import { BASE, INPUT_SHAPES, INPUT_STATES, isValidSize, SIZES, TYPES } from './config.js';
import { checkIfValidNumberInput } from './helper.js';
import { jsx as _jsx } from "react/jsx-runtime";
var AtomInput = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var type = _ref.type,
    shape = _ref.shape,
    charsSize = _ref.charsSize,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? SIZES.MEDIUM : _ref$size,
    noBorder = _ref.noBorder,
    errorState = _ref.errorState,
    state = _ref.state,
    disabled = _ref.disabled,
    readOnly = _ref.readOnly,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  return /*#__PURE__*/_jsx("span", {
    className: cx(BASE, shape && BASE + "-shape-" + shape, size && BASE + "-size-" + size, noBorder && BASE + "-borderless", disabled && BASE + "--is-disabled", readOnly && BASE + "--is-read-only", isValidSize(charsSize) && BASE + "--has-charSize", errorState && BASE + "--status-" + INPUT_STATES.ERROR, errorState === false && BASE + "--status-" + INPUT_STATES.SUCCESS, state && BASE + "--status-" + state),
    children: /*#__PURE__*/_jsx(Input, _extends({
      ref: ref
    }, _extends({
      disabled: disabled,
      readOnly: readOnly,
      type: type,
      noBorder: noBorder,
      errorState: errorState,
      state: state,
      charsSize: charsSize,
      shape: shape,
      size: size
    }, type === 'number' && {
      onKeyDown: checkIfValidNumberInput
    }, props)))
  });
});
AtomInput.displayName = 'AtomInput';
export default AtomInput;
export { SIZES as inputSizes, INPUT_STATES as inputStates, TYPES as inputTypes, INPUT_SHAPES as inputShapes };